<html>
<head>
<title>OGRE: OgreSkeletonFileFormat.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li><a href="classes.html"><span>Classes</span></a></li>
    <li class="current"><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="dir_d6c9b501d36b850bf0bac687671293db.html">OgreMain</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_f35e1e76cd4423745a1cccb1f171d4e3.html">include</a></div>
<h1>OgreSkeletonFileFormat.h</h1><a href="OgreSkeletonFileFormat_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2006 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Also see acknowledgements in Readme.html</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">This program is free software; you can redistribute it and/or modify it under</span>
<a name="l00011"></a>00011 <span class="comment">the terms of the GNU Lesser General Public License as published by the Free Software</span>
<a name="l00012"></a>00012 <span class="comment">Foundation; either version 2 of the License, or (at your option) any later</span>
<a name="l00013"></a>00013 <span class="comment">version.</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">This program is distributed in the hope that it will be useful, but WITHOUT</span>
<a name="l00016"></a>00016 <span class="comment">ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS</span>
<a name="l00017"></a>00017 <span class="comment">FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">You should have received a copy of the GNU Lesser General Public License along with</span>
<a name="l00020"></a>00020 <span class="comment">this program; if not, write to the Free Software Foundation, Inc., 59 Temple</span>
<a name="l00021"></a>00021 <span class="comment">Place - Suite 330, Boston, MA 02111-1307, USA, or go to</span>
<a name="l00022"></a>00022 <span class="comment">http://www.gnu.org/copyleft/lesser.txt.</span>
<a name="l00023"></a>00023 <span class="comment"></span>
<a name="l00024"></a>00024 <span class="comment">You may alternatively use this source under the terms of a specific version of</span>
<a name="l00025"></a>00025 <span class="comment">the OGRE Unrestricted License provided you have obtained such a license from</span>
<a name="l00026"></a>00026 <span class="comment">Torus Knot Software Ltd.</span>
<a name="l00027"></a>00027 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00028"></a>00028 <span class="comment">*/</span>
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __SkeletonFileFormat_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __SkeletonFileFormat_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include "<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>"</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="keyword">namespace </span>Ogre {
<a name="l00035"></a>00035 
<a name="l00050"></a><a class="code" href="namespaceOgre.html#5b37bdf2f67384dbd81643164545f7bd">00050</a>     <span class="keyword">enum</span> <a class="code" href="namespaceOgre.html#5b37bdf2f67384dbd81643164545f7bd" title="Definition of the OGRE .skeleton file format.">SkeletonChunkID</a> {
<a name="l00051"></a><a class="code" href="namespaceOgre.html#5b37bdf2f67384dbd81643164545f7bd7ed2511945645204fe9f7423e32aea49">00051</a>         <a class="code" href="namespaceOgre.html#5b37bdf2f67384dbd81643164545f7bd7ed2511945645204fe9f7423e32aea49">SKELETON_HEADER</a>            = 0x1000,
<a name="l00052"></a>00052             <span class="comment">// char* version           : Version number check</span>
<a name="l00053"></a><a class="code" href="namespaceOgre.html#5b37bdf2f67384dbd81643164545f7bdacf798731cab07af608a45eb331faa01">00053</a>         <a class="code" href="namespaceOgre.html#5b37bdf2f67384dbd81643164545f7bdacf798731cab07af608a45eb331faa01">SKELETON_BONE</a>              = 0x2000,
<a name="l00054"></a>00054         <span class="comment">// Repeating section defining each bone in the system. </span>
<a name="l00055"></a>00055         <span class="comment">// Bones are assigned indexes automatically based on their order of declaration</span>
<a name="l00056"></a>00056         <span class="comment">// starting with 0.</span>
<a name="l00057"></a>00057 
<a name="l00058"></a>00058             <span class="comment">// char* name                       : name of the bone</span>
<a name="l00059"></a>00059             <span class="comment">// unsigned short handle            : handle of the bone, should be contiguous &amp; start at 0</span>
<a name="l00060"></a>00060             <span class="comment">// Vector3 position                 : position of this bone relative to parent </span>
<a name="l00061"></a>00061             <span class="comment">// Quaternion orientation           : orientation of this bone relative to parent </span>
<a name="l00062"></a>00062             <span class="comment">// Vector3 scale                    : scale of this bone relative to parent </span>
<a name="l00063"></a>00063 
<a name="l00064"></a><a class="code" href="namespaceOgre.html#5b37bdf2f67384dbd81643164545f7bd60d951d9cd1e76668758a78eaa75e3af">00064</a>         <a class="code" href="namespaceOgre.html#5b37bdf2f67384dbd81643164545f7bd60d951d9cd1e76668758a78eaa75e3af">SKELETON_BONE_PARENT</a>       = 0x3000,
<a name="l00065"></a>00065         <span class="comment">// Record of the parent of a single bone, used to build the node tree</span>
<a name="l00066"></a>00066         <span class="comment">// Repeating section, listed in Bone Index order, one per Bone</span>
<a name="l00067"></a>00067 
<a name="l00068"></a>00068             <span class="comment">// unsigned short handle             : child bone</span>
<a name="l00069"></a>00069             <span class="comment">// unsigned short parentHandle   : parent bone</span>
<a name="l00070"></a>00070 
<a name="l00071"></a><a class="code" href="namespaceOgre.html#5b37bdf2f67384dbd81643164545f7bda559ee7367718e8c9ffdfd1af83c9ca8">00071</a>         <a class="code" href="namespaceOgre.html#5b37bdf2f67384dbd81643164545f7bda559ee7367718e8c9ffdfd1af83c9ca8">SKELETON_ANIMATION</a>         = 0x4000,
<a name="l00072"></a>00072         <span class="comment">// A single animation for this skeleton</span>
<a name="l00073"></a>00073 
<a name="l00074"></a>00074             <span class="comment">// char* name                       : Name of the animation</span>
<a name="l00075"></a>00075             <span class="comment">// float length                      : Length of the animation in seconds</span>
<a name="l00076"></a>00076 
<a name="l00077"></a><a class="code" href="namespaceOgre.html#5b37bdf2f67384dbd81643164545f7bd691013153a33fde3a543deed39382c20">00077</a>             <a class="code" href="namespaceOgre.html#5b37bdf2f67384dbd81643164545f7bd691013153a33fde3a543deed39382c20">SKELETON_ANIMATION_TRACK</a> = 0x4100,
<a name="l00078"></a>00078             <span class="comment">// A single animation track (relates to a single bone)</span>
<a name="l00079"></a>00079             <span class="comment">// Repeating section (within SKELETON_ANIMATION)</span>
<a name="l00080"></a>00080                 
<a name="l00081"></a>00081                 <span class="comment">// unsigned short boneIndex     : Index of bone to apply to</span>
<a name="l00082"></a>00082 
<a name="l00083"></a><a class="code" href="namespaceOgre.html#5b37bdf2f67384dbd81643164545f7bdebf5354fd4093986740b6f7a0b9c998e">00083</a>                 <a class="code" href="namespaceOgre.html#5b37bdf2f67384dbd81643164545f7bdebf5354fd4093986740b6f7a0b9c998e">SKELETON_ANIMATION_TRACK_KEYFRAME</a> = 0x4110,
<a name="l00084"></a>00084                 <span class="comment">// A single keyframe within the track</span>
<a name="l00085"></a>00085                 <span class="comment">// Repeating section</span>
<a name="l00086"></a>00086 
<a name="l00087"></a>00087                     <span class="comment">// float time                    : The time position (seconds)</span>
<a name="l00088"></a>00088                     <span class="comment">// Quaternion rotate            : Rotation to apply at this keyframe</span>
<a name="l00089"></a>00089                     <span class="comment">// Vector3 translate            : Translation to apply at this keyframe</span>
<a name="l00090"></a>00090                     <span class="comment">// Vector3 scale                : Scale to apply at this keyframe</span>
<a name="l00091"></a><a class="code" href="namespaceOgre.html#5b37bdf2f67384dbd81643164545f7bd869ed880064984ab52e95a922efec6cd">00091</a>         <a class="code" href="namespaceOgre.html#5b37bdf2f67384dbd81643164545f7bd869ed880064984ab52e95a922efec6cd">SKELETON_ANIMATION_LINK</a>         = 0x5000
<a name="l00092"></a>00092         <span class="comment">// Link to another skeleton, to re-use its animations</span>
<a name="l00093"></a>00093 
<a name="l00094"></a>00094             <span class="comment">// char* skeletonName                   : name of skeleton to get animations from</span>
<a name="l00095"></a>00095             <span class="comment">// float scale                          : scale to apply to trans/scale keys</span>
<a name="l00096"></a>00096 
<a name="l00097"></a>00097     };
<a name="l00098"></a>00098 
<a name="l00099"></a>00099 } <span class="comment">// namespace</span>
<a name="l00100"></a>00100 
<a name="l00101"></a>00101 
<a name="l00102"></a>00102 <span class="preprocessor">#endif</span>
</pre></div><hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:48:56 2008
</p>
</body>
</html>
